/** Kevin Harris
  * CS431
  * Program 2
  * Fall 1997
  *
  * Notes:
  *   =This is NOT the original version that I handed in for class.  I have
  *    modified it (14Jan2002) to get rid of the popup control window (not good
  *    in a browser), and to fix the keylistener portion, so that the keyboard
  *    keys work (arrows/keypad)
  */

import java.awt.*;
import java.applet.Applet;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;


class Program2Canvas extends java.awt.Canvas
{
  public Ship someship;

  public Program2Canvas()
  {
    someship = new Ship();
    someship.Translate(200,200);
  }
  public void paint(Graphics g)
  {
    someship.update(1);
    someship.paint(g);
  }

};
     
//========================================================================
//end of useful classes, main follows.
//========================================================================
public class Program2 extends Applet implements Runnable, KeyListener, MouseListener
{
  protected Thread somethread;
  protected Program2Canvas canvas;

protected Label thrust = new Label("^");
  protected Label reverse = new Label("v");
  protected Label rotateCCW = new Label("<");
  protected Label rotateCW = new Label(">");

  public Program2()
  {
    // Background
    thrust.setBackground(Color.black);
    reverse.setBackground(Color.black);
    rotateCCW.setBackground(Color.black);
    rotateCW.setBackground(Color.black);
    // Foreground
    thrust.setForeground(Color.white);
    reverse.setForeground(Color.white);
    rotateCCW.setForeground(Color.white);
    rotateCW.setForeground(Color.white);
    // Listeners
    thrust.addMouseListener(this);
    reverse.addMouseListener(this);
    rotateCCW.addMouseListener(this);
    rotateCW.addMouseListener(this);
    // Alignment
    thrust.setAlignment(Label.CENTER);
    reverse.setAlignment(Label.CENTER);
    rotateCCW.setAlignment(Label.CENTER);
    rotateCW.setAlignment(Label.CENTER);

    // Layout.
    setLayout(new BorderLayout());
    add(thrust, BorderLayout.NORTH);
    add(reverse, BorderLayout.SOUTH);
    add(rotateCCW, BorderLayout.WEST);
    add(rotateCW, BorderLayout.EAST);    
    
    
    // Canvas stuff.
    canvas = new Program2Canvas();
    add(canvas);

    // Key listeners.
    canvas.addKeyListener(this); 
    this.addKeyListener(this); 
    thrust.addKeyListener(this);
    reverse.addKeyListener(this);
    rotateCCW.addKeyListener(this);        
    rotateCW.addKeyListener(this);    

    // Thread stuff.
    somethread = new Thread(this);
    somethread.start();
  }
  public static void main(String[] args)
  {
  }
  
  public void run()
  {
    while(true)
    {
      canvas.repaint();
      try
      {
        Thread.sleep(100);
      }
      catch(java.lang.InterruptedException excep)
      { //do nothing yet. (possibly something in the future)
      }
    }
  }
  /*
  public void paint(Graphics g)
  {
    canvas.paint(g);
  }
  */
  public void keyTyped(KeyEvent e){} 
  public void keyPressed(KeyEvent e)
  {
    int keyval = e.getKeyCode();
    if((keyval == KeyEvent.VK_LEFT)||(keyval == KeyEvent.VK_NUMPAD4))
    {
      canvas.someship.AngularAccelerate = -1;
    }
    else if((keyval == KeyEvent.VK_RIGHT)||(keyval == KeyEvent.VK_NUMPAD6))
    {
      canvas.someship.AngularAccelerate = 1;
    }
    else if((keyval == KeyEvent.VK_UP)||(keyval == KeyEvent.VK_NUMPAD8))
    {
      canvas.someship.Accelerate = 1;
    }
    else if((keyval == KeyEvent.VK_DOWN)||(keyval == KeyEvent.VK_NUMPAD2))
    {
      canvas.someship.Accelerate = -1;
    }    
  }
  public void keyReleased(KeyEvent e)
  {
    int keyval = e.getKeyCode();
    if((keyval == KeyEvent.VK_LEFT)||(keyval == KeyEvent.VK_NUMPAD4))
    {
      canvas.someship.AngularAccelerate = 0;
    }
    else if((keyval == KeyEvent.VK_RIGHT)||(keyval == KeyEvent.VK_NUMPAD6))
    {
      canvas.someship.AngularAccelerate = 0;
    }
    else if((keyval == KeyEvent.VK_UP)||(keyval == KeyEvent.VK_NUMPAD8))
    {
      canvas.someship.Accelerate = 0;
    }
    else if((keyval == KeyEvent.VK_DOWN)||(keyval == KeyEvent.VK_NUMPAD2))
    {
      canvas.someship.Accelerate = 0;
    }    
  }
  protected void MouseHandle(MouseEvent event, int val, Color col)
  {
    Label source = null;
    if(event.getSource() == thrust)
    {
      source = thrust;
      canvas.someship.Accelerate = val;
    }
    else if(event.getSource() == reverse)
    {
      source = reverse;
      canvas.someship.Accelerate = -val;
    }
    else if(event.getSource() == rotateCCW)
    {
      source = rotateCCW;
      canvas.someship.AngularAccelerate = -val;
    }
    else if(event.getSource() == rotateCW)
    {
      source = rotateCW;
      canvas.someship.AngularAccelerate = val;
    }
    if( source != null )
    {
      source.setForeground(col);
    }
  }
  
  public void mouseEntered(MouseEvent event)
  {
    MouseHandle(event, 1, Color.green);
  }
  public void mouseExited(MouseEvent event)
  {
    MouseHandle(event, 0, Color.white);
  }
  public void mousePressed(MouseEvent event) {}
  public void mouseReleased(MouseEvent event) {}
  public void mouseClicked(MouseEvent event) {}  
}
